#if !defined(AFX_SERVERTASK_H__35872569_30FB_4C61_BBB7_12573AE413C0__INCLUDED_)
#define AFX_SERVERTASK_H__35872569_30FB_4C61_BBB7_12573AE413C0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ServerTask.h : header file
//

class CServerDlg;

struct fifo_buffer
{
	char* buf_;
	DWORD size_, write_, read_;
	
	fifo_buffer()
	{
		buf_ = 0;
		size_ = 0;
		write_ = 0;
		read_ = 0;
	}
	~fifo_buffer()
	{
		if ( 0!=buf_ )
		{
			free(buf_);
			buf_ = 0;
		}
	}
	bool empty()
	{
		return (write_==read_);
	}
	DWORD write(char* data, DWORD len)
	{
		if ( 0==data || 0==len )
			return 0;
		if ( write_+len>size_ )
		{
			DWORD used = write_-read_;
			if ( used+len<size_ )
			{
				memmove(buf_, buf_+read_, used);
				read_ = 0;
				write_ = used;
			}
			else
			{
				DWORD cb = (used+len+1500) & (~1023);
				char* new_buf = (char*)malloc( cb );
				if ( 0==new_buf )
					return 0;
				if ( 0!=buf_)
				{
					memcpy(new_buf, buf_+read_, used);
					read_ = 0;
					write_ = used;
					free(buf_);
				}
				buf_ = new_buf;
				size_ = cb;
			}
		}
		memcpy(buf_+write_, data, len);
		write_ += len;
		return len;
	}
	char* read_ptr()
	{
		return (buf_+read_);
	}
	DWORD length()
	{
		return (0!=buf_ && read_<write_) ? (write_-read_) : 0;
	}
	void reduce(DWORD len)
	{
		read_ += len;
		if ( read_>=write_ )
		{
			read_ = 0;
			write_ = 0;
		}
	}
};


/////////////////////////////////////////////////////////////////////////////
// CServerTask command target

class CServerTask : public CAsyncSocket
{
// Attributes
public:
	CServerDlg* m_pDlg;
	SOCKADDR m_addr;
	bool m_bSentFiles;

	long m_obj_media; //"media file" object
	long m_obj_codec; //"audio codec" object
	I_sample_port* m_sp_audio; //used to receive compressed samples

	fifo_buffer m_sendbuf; //buffer for sending

// Operations
public:
	CServerTask(CServerDlg* dlg, CAsyncSocket& sock, SOCKADDR& addr);
	virtual ~CServerTask();

	void OnFilesChanged();
	void OnAudcOutput(I_sample_port* port);

// Overrides
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CServerTask)
	public:
	virtual void OnClose(int nErrorCode);
	virtual void OnReceive(int nErrorCode);
	virtual void OnSend(int nErrorCode);
	virtual int Send(const void* lpBuf, int nBufLen, int nFlags = 0);
	//}}AFX_VIRTUAL

	// Generated message map functions
	//{{AFX_MSG(CServerTask)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
protected:
	int HandlePack();
	void SendError(BYTE pk_type, BYTE err_code);
	void SendAudio(BYTE* buf, DWORD len, DWORD stamp);

	void OnFileList();
	void OnPlay(PackString* filename);

	char* m_buf;
	UINT m_buf_size, m_buf_used;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERVERTASK_H__35872569_30FB_4C61_BBB7_12573AE413C0__INCLUDED_)
