#if !defined __PROTOCOL__
#define __PROTOCOL__

#define LISTEN_PORT 7958

struct Packet
{
	char mark[2];
	unsigned char type, code;
	int data_len;

	char* data() 
	{
		return (char*)(this+1); 
	}
	size_t size()
	{
		return sizeof(Packet)+data_len;
	}
	void* end()
	{
		return data()+data_len;
	}
	void init(u_char t)
	{
		mark[0]='P';
		mark[1]='H';
		type = t;
		code = 0;
		data_len = 0;
	}
	bool verify(int max_data_len)
	{
		return ('P'==mark[0] && 'H'==mark[1]) && (data_len>=0 && data_len<max_data_len);
	}
};

enum //pack type
{
	PKT_FILE_LIST = 1,
	PKT_PLAY = 2,
	PKT_AUDIO_DATA = 3
};

enum //error code
{
	DEMO_NOERROR = 0,
	DEMO_ERR_LOAD_FILE = 1,
	DEMO_ERR_NO_AUDIO = 2,
	DEMO_ERR_LOAD_AUDC = 3,
	DEMO_ERR_OPEN_AUDC = 4,
	DEMO_ERR_OUTPUT = 5
};

struct PackString
{
	unsigned short len;

	void set(char* buf, unsigned short buf_len)
	{
		len = buf_len;
		memcpy(this+1, buf, buf_len);
	}
	unsigned short get(char* buf, unsigned short buf_len)
	{
		if ( len<buf_len )
		{
			memcpy(buf, this+1, len);
			buf[len] = 0;
			return len;
		}
		return 0;
	}
	void* end()
	{
		return (char*)(this+1)+len;
	}
};

#endif //__PROTOCOL__
