#if !defined __SAMPLE_PORT__
#define __SAMPLE_PORT__

struct I_sample : public IUnknown	//represents a sample
{
	virtual DWORD	get_timestamp(void) = 0;
	virtual DWORD	get_length(void) = 0;
	virtual BYTE*	get_buffer(void) = 0;
	virtual WORD	get_flag(void) = 0;
};
enum // I_sample::get_flag
{
	SF_KEY_FRAME = 1
};

struct I_sample_port : public IUnknown
{
	virtual I_sample*	pull(void) = 0;
	virtual const void*	get_format(DWORD* pBytes) = 0;
			// pointer to (WAVEFORMATEX*) or (BITMAPINFO*), depend on major type.
	virtual DWORD		get_framerate(void) = 0;
	virtual BOOL		is_closed(void) = 0;
};

struct I_output
{
	virtual I_sample_port* new_port(DWORD dwCallback, DWORD dwContext, DWORD dwFlag) = 0;
	virtual GUID major_type(void) = 0;
	virtual GUID sub_type(void) = 0;
};
enum // dwFlag of I_output::new_port
{ 
	SP_FLAG_NULL = 0x00000000l,    // no callback
	SP_FLAG_WINDOW = 0x00010000l,  // dwCallback is a HWND
	SP_FLAG_THREAD = 0x00020000l,  // dwCallback is a THREAD ID
	SP_FLAG_EVENT = 0x00050000l    // dwCallback is an EVENT Handle
};
enum
{	// if (SP_FLAG_WINDOW==dwFlag || SP_FLAG_THREAD==dwFlag) then post the message WM_SAMPLE_PORT to notify.
	WM_SAMPLE_PORT = (WM_USER+52)
	// wParam: (I_sample_port*)
	// lParam: dwContext
};

struct I_source // for "source" object
{
	virtual BOOL init(	char* major_type, //either "video" or "audio"
						void* pFormat, DWORD dwFormatSize,
						DWORD dwFrameRate ) = 0;
	virtual void push( I_sample* pSample ) = 0;
	virtual void push( BYTE* pData, DWORD dwSize, DWORD dwTimestamp ) = 0;
};

#endif //__SAMPLE_PORT__